//package dreamplayer;

import javax.media.*;
import com.sun.media.ui.*;
import javax.media.protocol.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.lang.*;
import java.util.Vector;

/*
  SIPManagement is the main class for the SIP-functionality of the dreamplayer
*/

public class SIPManagement {

ServerSide serverSock;
Socket clientSock;
Socket socket1;
DataInputStream inStream;
DataOutputStream outStream;
JMStudio jmstudio;
public String own_e_mail_addr="";
public String foreign_e_mail_addr="";
public String own_name="";
public String foreign_name="";

//very important debug information
boolean debug1=false;
//debug information, normal level
boolean debug2=false;
//unimportant debug information
boolean debug3=false;
//shows the sip protocol stack
boolean show_sip_stack=true;
//true, if an error occured in the current method
boolean error_occured=false;
//true, if the serverSock is already created
boolean serverSock_already_created=false;

  public SIPManagement(JMStudio _jmstudio) {
  jmstudio=_jmstudio;
  }

  // button_invite sends an INVITE-events to the specified partner
  public void button_invite(String _name_receiver, String _email_receiver, String _dest_ip_addr, String _comment, String _ip_streaming_addr){

    if (debug3) sipLogMessages("'Invite' pressed");
    if (!clientSocketWrite("INVITE", _email_receiver, own_e_mail_addr, _name_receiver,
                            own_name, "", "0",_ip_streaming_addr,_dest_ip_addr,_comment))
        { sipLogMessages("Sorry, the player was not able to connect to "+_dest_ip_addr);
          String message = "Sorry, \nes konnte keine Verbindung " + (_dest_ip_addr.length()==0 ? "" : "zu ("+_dest_ip_addr+") ")
             +"hergestellt werden!";
          JOptionPane jop = new JOptionPane();
          jop.showConfirmDialog(null, message,"Information", JOptionPane.CLOSED_OPTION, 2);
         }

  }

  // button_accept sends an RESONSE 201 or RESPONSE 202 to the specified connection partner
  public void button_accept(String _ip_addr_invitator, String _ip_streaming_addr, String _comment,boolean accepted){


    if (accepted){
      if (!clientSocketWrite("201",foreign_e_mail_addr,own_e_mail_addr,foreign_name,
                              own_name, "", "0",_ip_streaming_addr,_ip_addr_invitator,_comment))
        { sipLogMessages("Sorry, the player was not able to send the ACCEPT (201)");
          JOptionPane jop = new JOptionPane();
          jop.showConfirmDialog(null, "Sorry, \nder Einladende ( "+_ip_addr_invitator+
          " ) konnte nicht benachrichtigt werden", "Information", JOptionPane.CLOSED_OPTION, 2);
        }}
    else{
      if (!clientSocketWrite("202",foreign_e_mail_addr,own_e_mail_addr,foreign_name,
                              own_name, "", "0",_ip_streaming_addr,_ip_addr_invitator,_comment))
        { sipLogMessages("Sorry, the player was not able to send the denied ACCEPT (202)");
          JOptionPane jop = new JOptionPane();
          jop.showConfirmDialog(null, "Sorry, \nder Einladende ( "+_ip_addr_invitator+
          " ) konnte nicht benachrichtigt werden", "Information", JOptionPane.CLOSED_OPTION, 2);
        }
        }

  }

  // button_server_start starts a socket, listening on port 8877 for incomming connections
  public void button_server_start(){

    if (debug3) sipLogMessages("'Start Server' pressed");
    serverSock=new ServerSide(8877,jmstudio);
    serverSock_already_created=true;

  }

  //this method forwards log messages to the JMStudio-class
  public void sipLogMessages(String _message) {

    jmstudio.show_log_messages(_message);

  }

  // this method connects to _dest_ip_addr and submits the wished _command. After the submission
  // the connection is closed again
  public boolean clientSocketWrite( String _command, String _foreign_e_mail_addr,String _own_e_mail_addr,
                                    String _foreign_name, String _own_name, String _proxy, String _timestamp,
                                    String _ip_streaming_addr, String _dest_ip_addr, String _comment) {
    // command=[ INVITE | ACK | INFO | 200 | 201 | 202 ]
    // proxy= host:port (<- moentan null)


    error_occured=false;
    //create the client socket and connect it with the server socket
    try {
            clientSock=new Socket(_dest_ip_addr,8877);
            if (debug1) sipLogMessages("The clientSock is connected to the server socket. The values of the clientSock are:");
            if (debug1) sipLogMessages(clientSock.toString());
    } catch (IOException e) {
                sipLogMessages("Error while initializing clientSock : " + e);
                //e.printStackTrace();
                error_occured=true;}

    if (error_occured) return false;

    //getting the outputstream for the client socket
    try {
          outStream=new DataOutputStream(clientSock.getOutputStream());
          if (debug2) sipLogMessages("clientSock.getOutputStream() successfully executed");
    } catch (IOException e) {
                  sipLogMessages("Error while executing clientSock.getOutputStream() : " + e);
                  error_occured=true;}

    if (error_occured) return false;

   try {
                // sending the information to the connection partner

                if (show_sip_stack) jmstudio.show_log_messages("\n---- BEGIN SIP-Protocol-Stack Send----");
                // line 1
                if (_command.equalsIgnoreCase("INVITE") ||
                    _command.equalsIgnoreCase("ACK") ||
                    _command.equalsIgnoreCase("INFO") )
                    { outStream.writeUTF(_command+" <sip:"+_foreign_e_mail_addr+"> SIP/2.0" );
                      if (show_sip_stack) jmstudio.show_log_messages(_command+" <sip:"+_foreign_e_mail_addr+"> SIP/2.0" );
                    }
                else
                    { String reason="";
                      if (_command.equalsIgnoreCase("200")) reason="OK";
                      if (_command.equalsIgnoreCase("201")) reason="Einladung akzeptiert";
                      if (_command.equalsIgnoreCase("202")) reason="Einladung abgelehnt";
                      outStream.writeUTF("SIP/2.0 " +_command+" "+reason);
                      if (show_sip_stack) jmstudio.show_log_messages("SIP/2.0 " +_command+" "+reason);
                    }
                // line 2
                outStream.writeUTF("Via: SIP/2.0/TCP "+_proxy); //_proxy ist momentan ungenutzt und enthlt einen Leerstring
                if (show_sip_stack) jmstudio.show_log_messages("Via: SIP/2.0/TCP "+_proxy);
                // line 3
                outStream.writeUTF("From: "+_own_name+" <sip:"+_own_e_mail_addr+">");
                if (show_sip_stack) jmstudio.show_log_messages("From: "+_own_name+" <sip:"+_own_e_mail_addr+">");
                // line 4
                outStream.writeUTF("To: "+_foreign_name+" <sip:"+_foreign_e_mail_addr+">");
                if (show_sip_stack) jmstudio.show_log_messages("To: "+_foreign_name+" <sip:"+_foreign_e_mail_addr+">");
                // line 5
                outStream.writeUTF("");
                if (show_sip_stack) jmstudio.show_log_messages("");
                // line 6
                outStream.writeUTF("o="+_timestamp); //_timestamp momentan ungenutzt und enthlt Leerstring
                if (show_sip_stack) jmstudio.show_log_messages("o="+_timestamp);
                // line 7
                outStream.writeUTF("c=IN IP4 "+ _ip_streaming_addr);
                if (show_sip_stack) jmstudio.show_log_messages("c=IN IP4 "+ _ip_streaming_addr);
                // line 8
                outStream.writeUTF("host sender: "+(InetAddress.getLocalHost()).getHostAddress());
                if (show_sip_stack) jmstudio.show_log_messages("host sender: "+(InetAddress.getLocalHost()).getHostAddress());
                // line 7
                outStream.writeUTF("host receiver: "+_dest_ip_addr);
                if (show_sip_stack) jmstudio.show_log_messages("host receiver: "+_dest_ip_addr);
                // line 10
                outStream.writeUTF("comment: "+_comment);
                if (show_sip_stack) jmstudio.show_log_messages("comment: "+_comment);

                if (show_sip_stack) jmstudio.show_log_messages("\n---- END SIP-Protocol-Stack Send----");

                if (debug2) sipLogMessages(_command +" successfully executed");

    } catch (IOException e) {
                  sipLogMessages("Error while executing writeUTF : " + e);
                  error_occured=true;}

    if (error_occured) return false;


    // closing the the client socket and the OutputStream
    try{
      outStream.close();
      if (debug3) sipLogMessages("outStream closed");
      } catch (IOException e){
                  sipLogMessages("Error while closing the outputStream : " + e);
                  error_occured=true;}
    if (error_occured) return false;
    try{
      clientSock.close();
      if (debug3) sipLogMessages("clientSock closed");
      } catch (IOException e){
                  sipLogMessages("Error while closing the client socket : " + e);
                  error_occured=true;}

    if (error_occured) return false;
    else return true;
  }

}
