//package dreamplayer;

import javax.media.*;
import com.sun.media.ui.*;
import javax.media.protocol.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.lang.*;
import java.util.Vector;

/*  ServerSide realizes the socket on port 8877, on which ever dreamplayer waits
    for new connections.

*/
public class ServerSide implements ActionListener, Runnable {

    DataInputStream inStream;
    DataOutputStream outStream;
    ServerSocket serverSock;
    Socket socket1;
    int port;
    JMStudio jmstudio;
    //debug1: important debug information
    boolean debug1=false;
    //debug2: normal priority
    boolean debug2=false;
    //debug3: unimportant debug information
    boolean debug3=false;
    //shows the sip protocol stack
    boolean show_sip_stack=true;

    ServerSide(int _port,JMStudio _jmstudio) {
        port=_port;
        jmstudio=_jmstudio;
        // Start the network reading thread.
        new Thread(this).start();
    }

    public void run() {
        try {

                serverSock=new ServerSocket(port,50,InetAddress.getLocalHost());
                if (debug1) jmstudio.show_log_messages("The address and port of the server socket: "
				+ serverSock.toString());
                jmstudio.show_log_messages("the player is now sip-able ...");

        } catch (Exception e) { jmstudio.show_log_messages("Error during the initial sequences of the sever socket" + e);}

        while (true) {
          try { socket1=serverSock.accept();
                if (debug2) jmstudio.show_log_messages("serverSock.accept successfully executed");
                if (debug3) {
                    jmstudio.show_log_messages("New socket (socket1) created. Some Informations :");
                    jmstudio.show_log_messages(socket1.toString());
                    jmstudio.show_log_messages("Remote port : "+Integer.toString(socket1.getPort()));
                    jmstudio.show_log_messages("Local port : "+Integer.toString(socket1.getLocalPort()));
                    }
                inStream=new DataInputStream(socket1.getInputStream());
                if (debug2) jmstudio.show_log_messages("socket1.getInputStream successfully executed");}
          catch (Exception e) {jmstudio.show_log_messages("Error while accepting socket1" + e);}


          try  {
                    while (true) {
                      // Wait for a line from the connection partner ...
                      String line1=inStream.readUTF();
                      String line2=inStream.readUTF();  if (show_sip_stack) {jmstudio.show_log_messages("\n---- BEGIN SIP-Protocol-Stack Received----");jmstudio.show_log_messages(line1);jmstudio.show_log_messages(line2);}
                      String line3=inStream.readUTF();  if (show_sip_stack) jmstudio.show_log_messages(line3);
                      String line4=inStream.readUTF();  if (show_sip_stack) jmstudio.show_log_messages(line4);
                      String line5=inStream.readUTF();  if (show_sip_stack) jmstudio.show_log_messages(line5);
                      String line6=inStream.readUTF();  if (show_sip_stack) jmstudio.show_log_messages(line6);
                      String line7=inStream.readUTF();  if (show_sip_stack) jmstudio.show_log_messages(line7);
                      String line8=inStream.readUTF();  if (show_sip_stack) jmstudio.show_log_messages(line8);
                      String line9=inStream.readUTF();  if (show_sip_stack) jmstudio.show_log_messages(line9);
                      String line10=inStream.readUTF(); if (show_sip_stack) jmstudio.show_log_messages(line10);
                      if (show_sip_stack) jmstudio.show_log_messages("----- END SIP-Protocol-Stack Received -----\n");

                      try{
                        inStream.close();
                        socket1.close();
                        if (debug3)
                          jmstudio.show_log_messages("socket1 sucessfully closed");
                      } catch (IOException e2) {
                        jmstudio.show_log_messages("Error while closing the server's socket1" + e2);
                      }

                      //getting the needed information out of the strings ....
                      String command   =line1.substring(0,line1.indexOf(" "));
                      String status=" ";
                      String reason=" ";
                      if (command.equalsIgnoreCase("SIP/2.0")) {
                        status  =line1.substring(line1.indexOf(" ")+1,line1.indexOf(" ")+4);
                        reason  =line1.substring(line1.indexOf(" ")+5,line1.length()); }

                      // foreign_name wird im SIP-Protokoll als own_name geliefert da es vom Kommunikationspartner kommt
                      String foreign_name         =line3.substring(line3.indexOf(" "),line3.indexOf("<sip")-1);
                      // foreign_e_mail_addr wird im SIP-Protokoll als own_e_mail_addr geliefert da es vom
                      // Kommunikationspartner kommt
                      String foreign_e_mail_addr  =line3.substring(line3.indexOf("<sip:")+5,line3.indexOf(">"));
                      // own_name wird im SIP-Protokoll als foreign_name geliefert da es vom Kommunikationspartner kommt
                      String own_name             =line4.substring(line4.indexOf(" "),line4.indexOf("<sip")-1);
                      // own_e_mail_addr wird im SIP-Protokoll als foreign_e_mail_addr geliefert da es vom
                      // Kommunikationspartner kommt
                      String own_e_mail_addr      =line4.substring(line4.indexOf("<sip:")+5,line4.indexOf(">"));

                      String timestamp            =line6.substring(3);
                      String ip_streaming_addr    =line7.substring(9);
                      String ip_addr_invitator    =line8.substring(13);
                      String own_ip_addr          =line9.substring(15);
                      String comment              =line10.substring(9);

                      if (debug3) jmstudio.show_log_messages("command: " + command);
                      if (debug3) jmstudio.show_log_messages("status: " + status);
                      if (debug3) jmstudio.show_log_messages("reason: " + reason);
                      if (debug3) jmstudio.show_log_messages("own_name: " + own_name);
                      if (debug3) jmstudio.show_log_messages("own-e_mail_addr: " + own_e_mail_addr);
                      if (debug3) jmstudio.show_log_messages("foreign_name: " + foreign_name);
                      if (debug3) jmstudio.show_log_messages("foreign_e_mail_addr: " + foreign_e_mail_addr);
                      if (debug3) jmstudio.show_log_messages("own_ip_addr: " + own_ip_addr);
                      if (debug3) jmstudio.show_log_messages("ip_addr_inivitator: " + ip_addr_invitator);
                      if (debug3) jmstudio.show_log_messages("ip_streaming_addr: " + ip_streaming_addr);
                      if (debug3) jmstudio.show_log_messages("comment: " + comment);


                      jmstudio.sipmanagement.foreign_name=foreign_name;
                      jmstudio.sipmanagement.foreign_e_mail_addr=foreign_e_mail_addr;

                      //responding to the events

                      // ----INVITE----
                      if (command.equalsIgnoreCase("INVITE"))
                          jmstudio.show_invitation(foreign_name,foreign_e_mail_addr,ip_addr_invitator,
                                                    ip_streaming_addr, comment);

                      // ----RESPONSE 200----
                      if (command.equalsIgnoreCase("SIP/2.0") && status.equalsIgnoreCase("200")){
                          //jmstudio.sipmanagement.clientSocketWrite("ACK",foreign_e_mail_addr,
                          //          jmstudio.sipmanagement.own_e_mail_addr, foreign_name,
                          //          jmstudio.sipmanagement.own_name,"", "0", ip_streaming_addr,
                          //          ip_addr_invitator, "");

                          if (debug1) jmstudio.show_log_messages("200 OK received");
                        }

                      // ----RESPONSE 201----
                      if (command.equalsIgnoreCase("SIP/2.0") && status.equalsIgnoreCase("201"))
                          { jmstudio.showStatusInvitation (foreign_name, ip_addr_invitator,
                                                         ip_streaming_addr, true);
                            jmstudio.sipmanagement.clientSocketWrite("ACK",foreign_e_mail_addr,
                                    jmstudio.sipmanagement.own_e_mail_addr, foreign_name,
                                    jmstudio.sipmanagement.own_name,"", "0", ip_streaming_addr,
                                    ip_addr_invitator, comment);
                            jmstudio.sipmanagement.clientSocketWrite("INFO", foreign_e_mail_addr,
                                    jmstudio.sipmanagement.own_e_mail_addr, foreign_name,
                                    jmstudio.sipmanagement.own_name,"", "0", ip_streaming_addr,
                                    ip_addr_invitator, comment);
                          }

                      // ----RESPONSE 202----
                      if (command.equalsIgnoreCase("SIP/2.0") && status.equalsIgnoreCase("202"))
                          { jmstudio.showStatusInvitation (foreign_name,ip_addr_invitator,
                                                         ip_streaming_addr, false);
                            jmstudio.sipmanagement.clientSocketWrite("ACK",foreign_e_mail_addr,
                                    jmstudio.sipmanagement.own_e_mail_addr,foreign_name,
                                    jmstudio.sipmanagement.own_name,"", "0", ip_streaming_addr,
                                    ip_addr_invitator, "");
                          }

                      // ----ACK----
                      if (command.equalsIgnoreCase("ACK")){
                          if (debug1) jmstudio.show_log_messages("ACK received");
                        }

                      // ----INFO----
                      if (command.equalsIgnoreCase("INFO")) {
                          if (debug1) jmstudio.show_log_messages("INFO received");
                          jmstudio.sipmanagement.clientSocketWrite("200",foreign_e_mail_addr,
                                    jmstudio.sipmanagement.own_e_mail_addr,foreign_name,
                                    jmstudio.sipmanagement.own_name,"", "0",
                                    ip_streaming_addr,  ip_addr_invitator, comment);
                          jmstudio.start_playing(ip_streaming_addr,timestamp);
                        }

                    }
                  }
                catch (IOException e) {   try{ inStream.close(); socket1.close();if (debug3) jmstudio.show_log_messages("socket1 sucessfully closed");}
                                          catch (IOException e2) {jmstudio.show_log_messages("Error while closing the server's socket1" + e);}
                                      }
              }
    }


    public void actionPerformed(ActionEvent evt) {
    }
}