package dreamplayer;
/*
 * Dreamplayer
 */

import javax.media.*;
import com.sun.media.ui.*;
import javax.media.protocol.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.util.Vector;

import javax.media.format.*;
import javax.media.datasink.*;
import javax.media.control.MonitorControl;


public class MDIApp extends Frame {

    /*************************************************************************
     * MAIN PROGRAM / STATIC METHODS
     *************************************************************************/

    public static void main(String args[]) {
	MDIApp mdi = new MDIApp();
    }

    static void Fatal(String s) {
	MessageBox mb = new MessageBox("JMF Error", s);
    }

    /*************************************************************************
     * VARIABLES
     *************************************************************************/
    SIPManagement sipmanagement=new SIPManagement();
    JMFrame jmframe = null;
    JDesktopPane desktop;
    FileDialog fd = null;
    CheckboxMenuItem cbAutoLoop = null;
    Player player = null;
    Player newPlayer = null;
    String filename;

    /*************************************************************************
     * METHODS
     *************************************************************************/

    public MDIApp() {
	super("Java Media Player");

	// Add the desktop pane
	setLayout( new BorderLayout() );
	desktop = new JDesktopPane();
	desktop.setDoubleBuffered(true);
	add("Center", desktop);
	setMenuBar(createMenuBar());
	setSize(640, 480);
	setVisible(true);

	try {
	    UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
	} catch (Exception e) {
	    System.err.println("Could not initialize java.awt Metal lnf");
	}
	addWindowListener( new WindowAdapter() {
	    public void windowClosing(WindowEvent we) {
		System.exit(0);
	    }
	} );

	Manager.setHint(Manager.LIGHTWEIGHT_RENDERER, new Boolean(true));
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    }

    private MenuBar createMenuBar() {
	ActionListener al = new ActionListener() {
	    public void actionPerformed(ActionEvent ae) {
		String command = ae.getActionCommand();
		if (command.equals("Open")) {
		    if (fd == null) {
			fd = new FileDialog(MDIApp.this, "Open File",
						       FileDialog.LOAD);
			fd.setDirectory("/movies");
		    }
		    fd.show();
		    if (fd.getFile() != null) {
			String filename = fd.getDirectory() + fd.getFile();
                        //openFile("http://localhost:80/sample.mov");
                        //System.out.println(filename);
			openFile("file:" + filename);
		    }
		} else if (command.equals("Exit")) {
		    dispose();
		    System.exit(0);
		}
                if (command.equals("Start Server")) {
		    sipmanagement.button_server_start();
		    }
                if (command.equals("Invite")) {
		    sipmanagement.button_invite();
		    }
                if (command.equals("Accept Invitation")) {
		    sipmanagement.button_accept();
		    }
                if (command.equals("Server read")) {
		    sipmanagement.button_server_read();
		    }
	    }
	};

	MenuItem item;
	MenuBar mb = new MenuBar();
	// File Menu
	Menu mnFile = new Menu("File");
	mnFile.add(item = new MenuItem("Open"));
	item.addActionListener(al);
	mnFile.add(item = new MenuItem("Exit"));
	item.addActionListener(al);

        // SIP Menu
	Menu mnSIP = new Menu("SIP");
        mnSIP.add(item = new MenuItem("Start Server"));
        item.addActionListener(al);
        mnSIP.add(item = new MenuItem("Server read"));
        item.addActionListener(al);
	mnSIP.add(item = new MenuItem("Invite"));
	item.addActionListener(al);
	mnSIP.add(item = new MenuItem("Accept Invitation"));
	item.addActionListener(al);

	// Options Menu
	Menu mnOptions = new Menu("Options");
	cbAutoLoop = new CheckboxMenuItem("Auto replay");
	cbAutoLoop.setState(true);
	mnOptions.add(cbAutoLoop);

	mb.add(mnFile);
        mb.add(mnSIP);
	mb.add(mnOptions);
	return mb;
    }

    /**
     * Open a media file.
     */
    public void openFile(String filename) {
        filename="rtsp://localhost:80/sample.mov";
	String mediaFile = filename;
	Player player = null;
	// URL for our media file
	URL url = null;
	try {
	    // Create an url from the file name and the url to the
	    // document containing this applet.
	   /* if ((url = new URL(mediaFile)) == null) {
		Fatal("Can't build URL for " + mediaFile);
		return;
	    }*/

	    // Create an instance of a player for this media
	    try {
                //url=new URL(url, "rtsp://localhost:80/sample.mov");
                //DataSource ds = new DataSource("rtsp://localhost:554/sample.mov");

                //Processor p = Manager.createProcessor();
                //	p.realize();
                //	p.prefetch();
                //p.start();
                MediaLocator ml = new MediaLocator("rtsp://127.0.0.1:554/test.mov");
                DataSource ds = Manager.createDataSource(ml);

		player = Manager.createPlayer(ds);
                //player = Manager.createRealizedPlayer(ds);
	    } catch (NoPlayerException e) {
		Fatal("RTSP1-Error: " + e);
	    }
        //} catch (CannotRealizeException e) {
        //    System.out.println(e);
        } catch (NoDataSourceException e) {
            System.out.println(e);
	} catch (MalformedURLException e) {
	    Fatal("RTSP2-Error: " + e);
            System.out.println("RTSP: "+e);
	} catch (IOException e) {
	    Fatal("RTSP3-Error: " + e);
	}
	if (player != null) {
	    this.filename = filename;
	    JMFrame jmframe = new JMFrame(player, filename);
	    desktop.add(jmframe);
	}
    }
  private void jbInit() throws Exception {
    this.setBackground(SystemColor.activeCaptionBorder);
  }
}

class JMFrame extends JInternalFrame implements ControllerListener {
    Player mplayer;
    Component visual = null;
    Component control = null;
    int videoWidth = 0;
    int videoHeight = 0;
    int controlHeight = 30;
    int insetWidth = 10;
    int insetHeight = 30;
    boolean firstTime = true;

    public JMFrame(Player player, String title) {
	super(title, true, true, true, true);
	getContentPane().setLayout( new BorderLayout() );
	setSize(320, 10);
	setLocation(50, 50);
	setVisible(true);
	mplayer = player;
	mplayer.addControllerListener((ControllerListener) this);
	mplayer.realize();
	addInternalFrameListener( new InternalFrameAdapter() {
	    public void internalFrameClosing(InternalFrameEvent ife) {
		mplayer.close();
	    }
	} );

    }

    public void controllerUpdate(ControllerEvent ce) {
	if (ce instanceof RealizeCompleteEvent) {
	    mplayer.prefetch();
	} else if (ce instanceof PrefetchCompleteEvent) {
	    if (visual != null)
		return;

	    if ((visual = mplayer.getVisualComponent()) != null) {
		Dimension size = visual.getPreferredSize();
		videoWidth = size.width;
		videoHeight = size.height;
		getContentPane().add("Center", visual);
	    } else
		videoWidth = 320;
	    if ((control = mplayer.getControlPanelComponent()) != null) {
		controlHeight = control.getPreferredSize().height;
		getContentPane().add("South", control);
	    }
	    setSize(videoWidth + insetWidth,
		    videoHeight + controlHeight + insetHeight);
	    validate();
	    mplayer.start();
	} else if (ce instanceof EndOfMediaEvent) {
	    mplayer.setMediaTime(new Time(0));
	    mplayer.start();
	}
    }
}
